from collections import defaultdict

def read_input():
    n, m, k = map(int, input().split(' '))
    dorog = defaultdict(list)
    for _ in range(m):
        a, b = map(int, input().split(' '))
        dorog[a].append(b)
        dorog[b].append(a)
    ohran = {}
    for _ in range(k):
        p, h = map(int, input().split(' '))
        ohran[p] = h
    return n, dorog, ohran

def bfs(start, dorog, ohran):
    queue = [(start, 0)]
    visited = set()
    protected = set()
    while queue:
        current, distance = queue.pop(0)
        if current in visited:
            continue
        visited.add(current)
        if current in ohran and ohran[current] >= distance:
            protected.add(current)
        for i in dorog[current]:
            if i not in visited:
                queue.append((i, distance + 1))
    return protected

def find_protected_warehouses(n, dorog, ohran):
    protected = set()
    for pos in ohran:
        protected.update(bfs(pos, dorog, ohran))
    return protected

n, dorog, ohran = read_input()
protected = find_protected_warehouses(n, dorog, ohran)
print(len(protected))
print(*sorted(protected))