from collections import defaultdict, deque

n, m, k = map(int, input().split())

graph = defaultdict(list)
for i in range(m):
    a, b = map(int, input().split())
    graph[a].append(b)
    graph[b].append(a)

ohran = {}
for i in range(k):
    p, h = map(int, input().split())
    ohran[p] = h

ohraned_warehouses = set()
for ohran_position, endurance in ohran.items():
    visited = set()
    queue = deque([(ohran_position, 0)])
    while queue:
        current_warehouse, distance = queue.popleft()
        if distance > endurance:
            continue
        if current_warehouse not in visited:
            visited.add(current_warehouse)
            ohraned_warehouses.add(current_warehouse)
            for i in graph[current_warehouse]:
                if i not in visited:
                    queue.append((i, distance + 1))

# Output the results
print(len(ohraned_warehouses))
if ohraned_warehouses:
    print(*sorted(ohraned_warehouses))