import math

def distance(x1, y1, x2, y2):
  return math.sqrt((x2 - x1) ** 2 + (y2 - y1) ** 2)

def tsp(points):
  n = len(points)
  dp = [[float('inf')] * n for _ in range(1 << n)]
  dp[1] = [0] * n

  for mask in range(2, 1 << n):
    for i in range(n):
      if mask & (1 << i):
        for j in range(n):
          if mask & (1 << j) and i != j:
            dp[mask][i] = min(dp[mask][i], dp[mask ^ (1 << i)][j] + distance(points[i][0], points[i][1], points[j][0], points[j][1]))

  min_dist = float('inf')
  for i in range(n):
    min_dist = min(min_dist, dp[(1 << n) - 1][i] + distance(points[i][0], points[i][1], points[0][0], points[0][1]))

  return min_dist

n = int(input())
points = []
for j in range(n):
  x, y = map(int, input().split())
  points.append((x, y))
print(tsp(points))